## libffado 2.0~rc1

=== SConstruct ===
#! /usr/bin/python
#
# Copyright (C) 2007-2008 Arnold Krille
# Copyright (C) 2007-2008 Pieter Palmers
# Copyright (C) 2008 Jonathan Woithe
#
# This file is part of FFADO
# FFADO = Free Firewire (pro-)audio drivers for linux
#
# FFADO is based upon FreeBoB.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

FFADO_API_VERSION="8"
FFADO_VERSION="1.999.40"

import os
import re
from string import Template
import imp

build_dir = ARGUMENTS.get('BUILDDIR', "")
if build_dir:
	build_base=build_dir+'/'
	if not os.path.isdir( build_base ):
		os.makedirs( build_base )
	print "Building into: " + build_base
else:
	build_base=''

destdir = ARGUMENTS.get( 'DESTDIR', "" )

if not os.path.isdir( "cache" ):
	os.makedirs( "cache" )

opts = Options( "cache/"+build_base+"options.cache" )

#
# If this is just to display a help-text for the variable used via ARGUMENTS, then its wrong...
opts.Add( "BUILDDIR", "Path to place the built files in", "")

opts.AddOptions(
	BoolOption( "DEBUG", """\
Toggle debug-build. DEBUG means \"-g -Wall\" and more, otherwise we will use
  \"-O2\" to optimise.""", True ),
	BoolOption( "PROFILE", "Build with symbols and other profiling info", False ),
	PathOption( "PREFIX", "The prefix where ffado will be installed to.", "/usr/local", PathOption.PathAccept ),
	PathOption( "BINDIR", "Overwrite the directory where apps are installed to.", "$PREFIX/bin", PathOption.PathAccept ),
	PathOption( "LIBDIR", "Overwrite the directory where libs are installed to.", "$PREFIX/lib", PathOption.PathAccept ),
	PathOption( "INCLUDEDIR", "Overwrite the directory where headers are installed to.", "$PREFIX/include", PathOption.PathAccept ),
	PathOption( "SHAREDIR", "Overwrite the directory where misc shared files are installed to.", "$PREFIX/share/libffado", PathOption.PathAccept ),
	BoolOption( "ENABLE_BEBOB", "Enable/Disable the bebob part.", True ),
	BoolOption( "ENABLE_FIREWORKS", "Enable/Disable the ECHO Audio FireWorks AV/C part.", True ),
	BoolOption( "ENABLE_MOTU", "Enable/Disable the MOTU part.", True ),
	BoolOption( "ENABLE_GENERICAVC", """\
Enable/Disable the the generic avc part (mainly used by apple).
  Note that disabling this option might be overwritten by other devices needing
  this code.""", False ),
	BoolOption( "ENABLE_ALL", "Enable/Disable support for all devices.", False ),
	BoolOption( "SERIALIZE_USE_EXPAT", "Use libexpat for XML serialization.", False ),
	BoolOption( "BUILD_TESTS", """\
Build the tests in their directory. As some contain quite some functionality,
  this is on by default.
  If you just want to use ffado with jack without the tools, you can disable this.\
""", True ),
    BoolOption( "BUILD_STATIC_TOOLS", "Build a statically linked version of the FFADO tools.", False ),
    EnumOption('DIST_TARGET', 'Build target for cross compiling packagers', 'auto', allowed_values=('auto', 'i386', 'i686', 'x86_64', 'powerpc', 'powerpc64', 'none' ), ignorecase=2),
    BoolOption( "ENABLE_OPTIMIZATIONS", "Enable optimizations and the use of processor specific extentions (MMX/SSE/...).", False ),

	)

## Load the builders in config
buildenv=os.environ
vars_to_check = [
	'PATH',
	'PKG_CONFIG_PATH',
	'LD_LIBRARY_PATH',
	'XDG_CONFIG_DIRS',
	'XDG_DATA_DIRS',
	'HOME',
	'CC',
	'CFLAGS',
	'CXX',
	'CXXFLAGS',
	'CPPFLAGS',
]
for var in vars_to_check:
	if os.environ.has_key(var):
		buildenv[var]=os.environ[var]
	else:
		buildenv[var]=''

env = Environment( tools=['default','scanreplace','pyuic','pyuic4','dbus','doxygen','pkgconfig'], toolpath=['admin'], ENV = buildenv, options=opts )

if os.environ.has_key('LDFLAGS'):
	env['LINKFLAGS'] = os.environ['LDFLAGS']

# grab OS CFLAGS / CCFLAGS
env['OS_CFLAGS']=[]
if os.environ.has_key('CFLAGS'):
	env['OS_CFLAGS'] = os.environ['CFLAGS']
env['OS_CCFLAGS']=[]
if os.environ.has_key('CCFLAGS'):
	env['OS_CCFLAGS'] = os.environ['CCFLAGS']

Help( """
For building ffado you can set different options as listed below. You have to
specify them only once, scons will save the last value you used and re-use
that.
To really undo your settings and return to the factory defaults, remove the
"cache"-folder and the file ".sconsign.dblite" from this directory.
For example with: "rm -Rf .sconsign.dblite cache"

Note that this is a development version! Don't complain if its not working!
See www.ffado.org for stable releases.
""" )
Help( opts.GenerateHelpText( env ) )

# make sure the necessary dirs exist
if not os.path.isdir( "cache/" + build_base ):
	os.makedirs( "cache/" + build_base )
if not os.path.isdir( 'cache/objects' ):
	os.makedirs( 'cache/objects' )

CacheDir( 'cache/objects' )

opts.Save( 'cache/' + build_base + "options.cache", env )

def ConfigGuess( context ):
	context.Message( "Trying to find the system triple: " )
	ret = os.popen( "admin/config.guess" ).read()[:-1]
	context.Result( ret )
	return ret

def CheckForApp( context, app ):
	context.Message( "Checking whether '" + app + "' executes " )
	ret = context.TryAction( app )
	context.Result( ret[0] )
	return ret[0]

def CheckForPyModule( context, module ):
	context.Message( "Checking for the python module '" + module + "' " )
	ret = True
	path = None
	while module.count(".") > 0 and ret:
		thismod = module.split(".")[0]
		try:
			modinfo = imp.find_module( thismod, path )
		except ImportError:
			ret = False
		else:
			newmod = imp.load_module( thismod, modinfo[0], modinfo[1], modinfo[2] )
			path = newmod.__path__
		module = ".".join( module.split(".")[1:] )
	if ret:
		try:
			imp.find_module( module )
		except ImportError:
			ret = False
	context.Result( ret )
	return ret

def CompilerCheck( context ):
	context.Message( "Checking for a working C-compiler " )
	ret = context.TryRun( """
#include <stdlib.h>

int main() {
	printf( "Hello World!" );
	return 0;
}""", '.c' )[0]
	context.Result( ret )
	if ret == 0:
		return False;
	context.Message( "Checking for a working C++-compiler " )
	ret = context.TryRun( """
#include <iostream>

int main() {
	std::cout << "Hello World!" << std::endl;
	return 0;
}""", ".cpp" )[0]
	context.Result( ret )
	return ret

tests = {
	"ConfigGuess" : ConfigGuess,
	"CheckForApp" : CheckForApp,
	"CheckForPyModule": CheckForPyModule,
	"CompilerCheck" : CompilerCheck,
}
tests.update( env['PKGCONFIG_TESTS'] )
tests.update( env['PYUIC_TESTS'] )
tests.update( env['PYUIC4_TESTS'] )

conf = Configure( env,
	custom_tests = tests,
	conf_dir = "cache/" + build_base,
	log_file = "cache/" + build_base + 'config.log' )

if env['SERIALIZE_USE_EXPAT']:
	env['SERIALIZE_USE_EXPAT']=1
else:
	env['SERIALIZE_USE_EXPAT']=0

if not env.GetOption('clean'):
	#
	# Check for working gcc and g++ compilers and their environment.
	#
	if not conf.CompilerCheck():
		print "\nIt seems as if your system isn't even able to compile any C-/C++-programs. Probably you don't have gcc and g++ installed. Compiling a package from source without a working compiler is very hard to do, please install the needed packages.\nHint: on *ubuntu you need both gcc- and g++-packages installed, easiest solution is to install build-essential which depends on gcc and g++."
		Exit( 1 )

	# Check for pkg-config before using pkg-config to check for other dependencies.
	if not conf.CheckForPKGConfig():
		print "\nThe program 'pkg-config' could not be found.\nEither you have to install the corresponding package first or make sure that PATH points to the right directions."
		Exit( 1 )

	#
	# The following checks are for headers and libs and packages we need.
	#
	allpresent = 1;
	# for DBUS C++ bindings
	allpresent &= conf.CheckHeader( "expat.h" )
	allpresent &= conf.CheckLib( 'expat', 'XML_ExpatVersion', '#include <expat.h>' )
	
	pkgs = {
		'libraw1394' : '1.3.0',
		'libiec61883' : '1.1.0',
		'dbus-1' : '1.0',
		}
	if not env['SERIALIZE_USE_EXPAT']:
		pkgs['libxml++-2.6'] = '2.13.0'

	for pkg in pkgs:
		name2 = pkg.replace("+","").replace(".","").replace("-","").upper()
		env['%s_FLAGS' % name2] = conf.GetPKGFlags( pkg, pkgs[pkg] )
		if env['%s_FLAGS'%name2] == 0:
			allpresent &= 0

	if not allpresent:
		print """
(At least) One of the dependencies is missing. I can't go on without it, please
install the needed packages for each of the lines saying "no".
(Remember to also install the *-devel packages!)

And remember to remove the cache with "rm -Rf .sconsign.dblite cache" so the
results above get rechecked.
"""
		Exit( 1 )

	# Check for C99 lrint() and lrintf() functions used to convert from
	# float to integer more efficiently via float_cast.h.  If not
	# present the standard slower methods will be used instead.  This
	# might not be the best way of testing for these but it's the only
	# way which seems to work properly.  CheckFunc() fails due to
	# argument count problems.
	if env.has_key( 'CFLAGS' ):
		oldcf = env['CFLAGS']
	else:
		oldcf = ""
	oldcf = env.Append(CFLAGS = '-std=c99')
	if conf.CheckLibWithHeader( "m", "math.h", "c", "lrint(3.2);" ):
		HAVE_LRINT = 1
	else:
		HAVE_LRINT = 0
	if conf.CheckLibWithHeader( "m", "math.h", "c", "lrintf(3.2);" ):
		HAVE_LRINTF = 1
	else:
		HAVE_LRINTF = 0
	env['HAVE_LRINT'] = HAVE_LRINT;
	env['HAVE_LRINTF'] = HAVE_LRINTF;
	env.Replace(CFLAGS=oldcf)

	#
	# Optional checks follow:
	#

	# PyQT checks
	build_mixer = False
	if conf.CheckForApp( 'which pyuic4' ) and conf.CheckForPyModule( 'dbus' ) and conf.CheckForPyModule( 'PyQt4' ) and conf.CheckForPyModule( 'dbus.mainloop.qt' ):
		env['PYUIC4'] = True
		build_mixer = True
	
	if conf.CheckForApp( 'which pyuic' ) and conf.CheckForPyModule( 'dbus' ) and conf.CheckForPyModule( 'qt' ):
		env['PYUIC'] = True
		build_mixer = True
	
	if conf.CheckForApp( 'xdg-desktop-menu --help' ):
		env['XDG_TOOLS'] = True
	else:
		print """
I couldn't find the program 'xdg-desktop-menu'. Together with xdg-icon-resource
this is needed to add the fancy entry to your menu. But the mixer will be installed, you can start it by executing "ffado-mixer".
"""
	
	if not build_mixer:
		print """
	I couldn't find all the prerequisites ('pyuic' / 'pyuic4' and the python-modules 'dbus' and
	'qt' / 'PyQt4', the packages could be named like dbus-python and PyQt) to build the mixer.
	Therefor neither the qt3 nor the qt4 mixer will get installed.
	"""

config_guess = conf.ConfigGuess()

env = conf.Finish()

if env['DEBUG']:
	print "Doing a DEBUG build"
	# -Werror could be added to, which would force the devs to really remove all the warnings :-)
	env.AppendUnique( CCFLAGS=["-DDEBUG","-Wall","-g"] )
	env.AppendUnique( CFLAGS=["-DDEBUG","-Wall","-g"] )
else:
	env.AppendUnique( CCFLAGS=["-O2","-DNDEBUG"] )
	env.AppendUnique( CFLAGS=["-O2","-DNDEBUG"] )

if env['PROFILE']:
	print "Doing a PROFILE build"
	# -Werror could be added to, which would force the devs to really remove all the warnings :-)
	env.AppendUnique( CCFLAGS=["-Wall","-g"] )
	env.AppendUnique( CFLAGS=["-Wall","-g"] )


# this is required to indicate that the DBUS version we use has support
# for platform dependent threading init functions
# this is true for DBUS >= 0.96 or so. Since we require >= 1.0 it is
# always true
env.AppendUnique( CCFLAGS=["-DDBUS_HAS_THREADS_INIT_DEFAULT"] )

if env['ENABLE_ALL']:
	env['ENABLE_BEBOB'] = True
	env['ENABLE_FIREWORKS'] = True
	env['ENABLE_MOTU'] = True

if env['ENABLE_BEBOB'] or env['ENABLE_FIREWORKS']:
	env['ENABLE_GENERICAVC'] = True

env['BUILD_STATIC_LIB'] = False
if env['BUILD_STATIC_TOOLS']:
    print "Building static versions of the tools..."
    env['BUILD_STATIC_LIB'] = True

## libffado 2.0~rc2+svn1569

=== SConstruct ===
--- 
+++ 
@@ -24,7 +24,7 @@
 #
 
 FFADO_API_VERSION="8"
-FFADO_VERSION="1.999.40"
+FFADO_VERSION="1.999.41"
 
 import os
 import re
@@ -40,8 +40,6 @@
 else:
 	build_base=''
 
-destdir = ARGUMENTS.get( 'DESTDIR', "" )
-
 if not os.path.isdir( "cache" ):
 	os.makedirs( "cache" )
 
@@ -54,7 +52,7 @@
 opts.AddOptions(
 	BoolOption( "DEBUG", """\
 Toggle debug-build. DEBUG means \"-g -Wall\" and more, otherwise we will use
-  \"-O2\" to optimise.""", True ),
+  \"-O2\" to optimize.""", True ),
 	BoolOption( "PROFILE", "Build with symbols and other profiling info", False ),
 	PathOption( "PREFIX", "The prefix where ffado will be installed to.", "/usr/local", PathOption.PathAccept ),
 	PathOption( "BINDIR", "Overwrite the directory where apps are installed to.", "$PREFIX/bin", PathOption.PathAccept ),
@@ -152,25 +150,9 @@
 
 def CheckForPyModule( context, module ):
 	context.Message( "Checking for the python module '" + module + "' " )
-	ret = True
-	path = None
-	while module.count(".") > 0 and ret:
-		thismod = module.split(".")[0]
-		try:
-			modinfo = imp.find_module( thismod, path )
-		except ImportError:
-			ret = False
-		else:
-			newmod = imp.load_module( thismod, modinfo[0], modinfo[1], modinfo[2] )
-			path = newmod.__path__
-		module = ".".join( module.split(".")[1:] )
-	if ret:
-		try:
-			imp.find_module( module )
-		except ImportError:
-			ret = False
-	context.Result( ret )
-	return ret
+	ret = context.TryAction( "python $SOURCE", "import %s" % module, ".py" )
+	context.Result( ret[0] )
+	return ret[0]
 
 def CompilerCheck( context ):
 	context.Message( "Checking for a working C-compiler " )
@@ -284,34 +266,34 @@
 	env['HAVE_LRINTF'] = HAVE_LRINTF;
 	env.Replace(CFLAGS=oldcf)
 
-	#
-	# Optional checks follow:
-	#
-
-	# PyQT checks
-	build_mixer = False
-	if conf.CheckForApp( 'which pyuic4' ) and conf.CheckForPyModule( 'dbus' ) and conf.CheckForPyModule( 'PyQt4' ) and conf.CheckForPyModule( 'dbus.mainloop.qt' ):
-		env['PYUIC4'] = True
-		build_mixer = True
-	
-	if conf.CheckForApp( 'which pyuic' ) and conf.CheckForPyModule( 'dbus' ) and conf.CheckForPyModule( 'qt' ):
-		env['PYUIC'] = True
-		build_mixer = True
-	
-	if conf.CheckForApp( 'xdg-desktop-menu --help' ):
-		env['XDG_TOOLS'] = True
-	else:
-		print """
+#
+# Optional checks follow:
+#
+
+# PyQT checks
+build_mixer = False
+if conf.CheckForApp( 'which pyuic4' ) and conf.CheckForPyModule( 'dbus' ) and conf.CheckForPyModule( 'PyQt4' ) and conf.CheckForPyModule( 'dbus.mainloop.qt' ):
+	env['PYUIC4'] = True
+	build_mixer = True
+
+if conf.CheckForApp( 'which pyuic' ) and conf.CheckForPyModule( 'dbus' ) and conf.CheckForPyModule( 'qt' ):
+	env['PYUIC'] = True
+	build_mixer = True
+
+if conf.CheckForApp( 'xdg-desktop-menu --help' ):
+	env['XDG_TOOLS'] = True
+else:
+	print """
 I couldn't find the program 'xdg-desktop-menu'. Together with xdg-icon-resource
 this is needed to add the fancy entry to your menu. But the mixer will be installed, you can start it by executing "ffado-mixer".
 """
-	
-	if not build_mixer:
-		print """
-	I couldn't find all the prerequisites ('pyuic' / 'pyuic4' and the python-modules 'dbus' and
-	'qt' / 'PyQt4', the packages could be named like dbus-python and PyQt) to build the mixer.
-	Therefor neither the qt3 nor the qt4 mixer will get installed.
-	"""
+
+if not build_mixer and not env.GetOption('clean'):
+	print """
+I couldn't find all the prerequisites ('pyuic' / 'pyuic4' and the python-modules 'dbus' and
+'qt' / 'PyQt4', the packages could be named like dbus-python and PyQt) to build the mixer.
+Therefor neither the qt3 nor the qt4 mixer will get installed.
+"""
 
 config_guess = conf.ConfigGuess()
 
@@ -319,25 +301,20 @@
 
 if env['DEBUG']:
 	print "Doing a DEBUG build"
-	# -Werror could be added to, which would force the devs to really remove all the warnings :-)
-	env.AppendUnique( CCFLAGS=["-DDEBUG","-Wall","-g"] )
-	env.AppendUnique( CFLAGS=["-DDEBUG","-Wall","-g"] )
-else:
-	env.AppendUnique( CCFLAGS=["-O2","-DNDEBUG"] )
-	env.AppendUnique( CFLAGS=["-O2","-DNDEBUG"] )
+	env.MergeFlags( "-DDEBUG -Wall -g" )
+else:
+	env.MergeFlags( "-O2 -DNDEBUG" )
 
 if env['PROFILE']:
 	print "Doing a PROFILE build"
-	# -Werror could be added to, which would force the devs to really remove all the warnings :-)
-	env.AppendUnique( CCFLAGS=["-Wall","-g"] )
-	env.AppendUnique( CFLAGS=["-Wall","-g"] )
+	env.MergeFlags( "-Wall -g" )
 
 
 # this is required to indicate that the DBUS version we use has support
 # for platform dependent threading init functions
 # this is true for DBUS >= 0.96 or so. Since we require >= 1.0 it is
 # always true
-env.AppendUnique( CCFLAGS=["-DDBUS_HAS_THREADS_INIT_DEFAULT"] )
+env.MergeFlags( "-DDBUS_HAS_THREADS_INIT_DEFAULT" )
 
 if env['ENABLE_ALL']:
 	env['ENABLE_BEBOB'] = True
@@ -352,3 +329,23 @@
     print "Building static versions of the tools..."
     env['BUILD_STATIC_LIB'] = True
 
+if build_base:
+	env['build_base']="#/"+build_base
+else:
+	env['build_base']="#/"
+
+#
+# Get the DESTDIR (if wanted) from the commandline
+#
+env.destdir = ARGUMENTS.get( 'DESTDIR', "" )
+
+#
+# Uppercase variables are for usage in code, lowercase versions for usage in
+# scons-files for installing.
+#
+env['BINDIR'] = Template( env['BINDIR'] ).safe_substitute( env )
+env['LIBDIR'] = Template( env['LIBDIR'] ).safe_substitute( env )
+env['INCLUDEDIR'] = Template( env['INCLUDEDIR'] ).safe_substitute( env )
+env['SHAREDIR'] = Template( env['SHAREDIR'] ).safe_substitute( env )
+env['bindir'] = Template( env.destdir + env['BINDIR'] ).safe_substitute( env )
+env['libdir'] = Template( env.destdir + env['LIBDIR'] ).safe_substitute( env )

## libffado 2.0.0

=== SConstruct ===
--- 
+++ 
@@ -1,4 +1,5 @@
 #! /usr/bin/python
+# -*- coding: utf-8 -*-
 #
 # Copyright (C) 2007-2008 Arnold Krille
 # Copyright (C) 2007-2008 Pieter Palmers
@@ -23,36 +24,23 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
 
-FFADO_API_VERSION="8"
-FFADO_VERSION="1.999.41"
+FFADO_API_VERSION = "8"
+FFADO_VERSION = "2.0.0"
 
 import os
 import re
 from string import Template
 import imp
 
-build_dir = ARGUMENTS.get('BUILDDIR', "")
-if build_dir:
-	build_base=build_dir+'/'
-	if not os.path.isdir( build_base ):
-		os.makedirs( build_base )
-	print "Building into: " + build_base
-else:
-	build_base=''
-
 if not os.path.isdir( "cache" ):
 	os.makedirs( "cache" )
 
-opts = Options( "cache/"+build_base+"options.cache" )
-
-#
-# If this is just to display a help-text for the variable used via ARGUMENTS, then its wrong...
-opts.Add( "BUILDDIR", "Path to place the built files in", "")
+opts = Options( "cache/options.cache" )
 
 opts.AddOptions(
 	BoolOption( "DEBUG", """\
 Toggle debug-build. DEBUG means \"-g -Wall\" and more, otherwise we will use
-  \"-O2\" to optimize.""", True ),
+  \"-O2\" to optimize.""", False ),
 	BoolOption( "PROFILE", "Build with symbols and other profiling info", False ),
 	PathOption( "PREFIX", "The prefix where ffado will be installed to.", "/usr/local", PathOption.PathAccept ),
 	PathOption( "BINDIR", "Overwrite the directory where apps are installed to.", "$PREFIX/bin", PathOption.PathAccept ),
@@ -127,14 +115,14 @@
 Help( opts.GenerateHelpText( env ) )
 
 # make sure the necessary dirs exist
-if not os.path.isdir( "cache/" + build_base ):
-	os.makedirs( "cache/" + build_base )
+if not os.path.isdir( "cache" ):
+	os.makedirs( "cache" )
 if not os.path.isdir( 'cache/objects' ):
 	os.makedirs( 'cache/objects' )
 
 CacheDir( 'cache/objects' )
 
-opts.Save( 'cache/' + build_base + "options.cache", env )
+opts.Save( 'cache/options.cache', env )
 
 def ConfigGuess( context ):
 	context.Message( "Trying to find the system triple: " )
@@ -189,8 +177,8 @@
 
 conf = Configure( env,
 	custom_tests = tests,
-	conf_dir = "cache/" + build_base,
-	log_file = "cache/" + build_base + 'config.log' )
+	conf_dir = "cache/",
+	log_file = 'cache/config.log' )
 
 if env['SERIALIZE_USE_EXPAT']:
 	env['SERIALIZE_USE_EXPAT']=1
@@ -329,10 +317,7 @@
     print "Building static versions of the tools..."
     env['BUILD_STATIC_LIB'] = True
 
-if build_base:
-	env['build_base']="#/"+build_base
-else:
-	env['build_base']="#/"
+env['build_base']="#/"
 
 #
 # Get the DESTDIR (if wanted) from the commandline
@@ -349,3 +334,20 @@
 env['SHAREDIR'] = Template( env['SHAREDIR'] ).safe_substitute( env )
 env['bindir'] = Template( env.destdir + env['BINDIR'] ).safe_substitute( env )
 env['libdir'] = Template( env.destdir + env['LIBDIR'] ).safe_substitute( env )
+env['includedir'] = Template( env.destdir + env['INCLUDEDIR'] ).safe_substitute( env )
+env['sharedir'] = Template( env.destdir + env['SHAREDIR'] ).safe_substitute( env )
+
+env.Command( target=env['sharedir'], source="", action=Mkdir( env['sharedir'] ) )
+
+env.Alias( "install", env['libdir'] )
+env.Alias( "install", env['includedir'] )
+env.Alias( "install", env['sharedir'] )
+env.Alias( "install", env['bindir'] )
+
+#
+# shamelessly copied from the Ardour scons file
+#
+
+opt_flags = []
+env['USE_SSE'] = 0
+

## libffado 2.0.1+svn1856

=== SConstruct ===
#! /usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) 2007, 2008, 2010 Arnold Krille
# Copyright (C) 2007, 2008 Pieter Palmers
# Copyright (C) 2008 Jonathan Woithe
#
# This file is part of FFADO
# FFADO = Free Firewire (pro-)audio drivers for linux
#
# FFADO is based upon FreeBoB.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

FFADO_API_VERSION = "8"
FFADO_VERSION="2.999.0"

import os
import re
from string import Template
import imp
import distutils.sysconfig

if not os.path.isdir( "cache" ):
	os.makedirs( "cache" )

opts = Options( "cache/options.cache" )

opts.AddOptions(
    BoolOption( "DEBUG", """\
Toggle debug-build. DEBUG means \"-g -Wall\" and more, otherwise we will use
  \"-O2\" to optimize.""", True ),
    BoolOption( "PROFILE", "Build with symbols and other profiling info", False ),
    PathOption( "PREFIX", "The prefix where ffado will be installed to.", "/usr/local", PathOption.PathAccept ),
    PathOption( "BINDIR", "Overwrite the directory where apps are installed to.", "$PREFIX/bin", PathOption.PathAccept ),
    PathOption( "LIBDIR", "Overwrite the directory where libs are installed to.", "$PREFIX/lib", PathOption.PathAccept ),
    PathOption( "INCLUDEDIR", "Overwrite the directory where headers are installed to.", "$PREFIX/include", PathOption.PathAccept ),
    PathOption( "SHAREDIR", "Overwrite the directory where misc shared files are installed to.", "$PREFIX/share/libffado", PathOption.PathAccept ),
    PathOption( "PYPKGDIR", "The directory where the python modules get installed.",
        distutils.sysconfig.get_python_lib( prefix="$PREFIX" ), PathOption.PathAccept ),
    BoolOption( "ENABLE_BEBOB", "Enable/Disable support for the BeBoB platform.", True ),
    BoolOption( "ENABLE_FIREWORKS", "Enable/Disable support for the ECHO Audio FireWorks platform.", True ),
    BoolOption( "ENABLE_OXFORD", "Enable/Disable support for the Oxford Semiconductor FW platform.", True ),
    BoolOption( "ENABLE_MOTU", "Enable/Disable support for the MOTU platform.", True ),
    BoolOption( "ENABLE_DICE", "Enable/Disable support for the TCAT DICE platform.", True ),
    BoolOption( "ENABLE_METRIC_HALO", "Enable/Disable support for the Metric Halo platform.", False ),
    BoolOption( "ENABLE_RME", "Enable/Disable support for the RME platform.", False ),
    BoolOption( "ENABLE_MAUDIO", "Enable/Disable support for the M-Audio custom BeBoB devices.", False ),
    BoolOption( "ENABLE_BOUNCE", "Enable/Disable the BOUNCE device.", False ),
    BoolOption( "ENABLE_GENERICAVC", """\
Enable/Disable the the generic avc part (mainly used by apple).
  Note that disabling this option might be overwritten by other devices needing
  this code.""", False ),
    BoolOption( "ENABLE_ALL", "Enable/Disable support for all devices.", False ),
    BoolOption( "SERIALIZE_USE_EXPAT", "Use libexpat for XML serialization.", False ),
    BoolOption( "BUILD_TESTS", """\
Build the tests in their directory. As some contain quite some functionality,
  this is on by default.
  If you just want to use ffado with jack without the tools, you can disable this.\
""", True ),
    BoolOption( "BUILD_STATIC_TOOLS", "Build a statically linked version of the FFADO tools.", False ),
    EnumOption('DIST_TARGET', 'Build target for cross compiling packagers', 'auto', allowed_values=('auto', 'i386', 'i686', 'x86_64', 'powerpc', 'powerpc64', 'none' ), ignorecase=2),
    BoolOption( "ENABLE_OPTIMIZATIONS", "Enable optimizations and the use of processor specific extentions (MMX/SSE/...).", False ),
    BoolOption( "PEDANTIC", "Enable -Werror and more pedantic options during compile.", False ),
    ( "COMPILE_FLAGS", "Add additional flags to the environment.\nOnly meant for distributors and gentoo-users who want to over-optimize their built.\n Using this is not supported by the ffado-devs!" ),

    )

## Load the builders in config
buildenv=os.environ

env = Environment( tools=['default','scanreplace','pyuic','pyuic4','dbus','doxygen','pkgconfig'], toolpath=['admin'], ENV = buildenv, options=opts )

if env.has_key('COMPILE_FLAGS') and len(env['COMPILE_FLAGS']) > 0:
    print '''
 * Usage of additional flags is not supported by the ffado-devs.
 * Use at own risk!
 *
 * Currentl value is '%s'
 ''' % env['COMPILE_FLAGS']
    env.MergeFlags(env['COMPILE_FLAGS'])

Help( """
For building ffado you can set different options as listed below. You have to
specify them only once, scons will save the last value you used and re-use
that.
To really undo your settings and return to the factory defaults, remove the
"cache"-folder and the file ".sconsign.dblite" from this directory.
For example with: "rm -Rf .sconsign.dblite cache"

Note that this is a development version! Don't complain if its not working!
See www.ffado.org for stable releases.
""" )
Help( opts.GenerateHelpText( env ) )

# make sure the necessary dirs exist
if not os.path.isdir( "cache" ):
	os.makedirs( "cache" )
if not os.path.isdir( 'cache/objects' ):
    os.makedirs( 'cache/objects' )

CacheDir( 'cache/objects' )

opts.Save( 'cache/options.cache', env )

def ConfigGuess( context ):
    context.Message( "Trying to find the system triple: " )
    ret = os.popen( "admin/config.guess" ).read()[:-1]
    context.Result( ret )
    return ret

def CheckForApp( context, app ):
    context.Message( "Checking whether '" + app + "' executes " )
    ret = context.TryAction( app )
    context.Result( ret[0] )
    return ret[0]

def CheckForPyModule( context, module ):
    context.Message( "Checking for the python module '" + module + "' " )
    ret = context.TryAction( "python $SOURCE", "import %s" % module, ".py" )
    context.Result( ret[0] )
    return ret[0]

def CompilerCheck( context ):
    context.Message( "Checking for a working C-compiler " )
    ret = context.TryRun( """
#include <stdio.h>

int main() {
    printf( "Hello World!" );
    return 0;
}""", '.c' )[0]
    context.Result( ret )
    if ret == 0:
        return False;
    context.Message( "Checking for a working C++-compiler " )
    ret = context.TryRun( """
#include <iostream>

int main() {
    std::cout << "Hello World!" << std::endl;
    return 0;
}""", ".cpp" )[0]
    context.Result( ret )
    return ret

tests = {
    "ConfigGuess" : ConfigGuess,
    "CheckForApp" : CheckForApp,
    "CheckForPyModule": CheckForPyModule,
    "CompilerCheck" : CompilerCheck,
}
tests.update( env['PKGCONFIG_TESTS'] )
tests.update( env['PYUIC_TESTS'] )
tests.update( env['PYUIC4_TESTS'] )

conf = Configure( env,
    custom_tests = tests,
    conf_dir = "cache/",
    log_file = 'cache/config.log' )

if env['SERIALIZE_USE_EXPAT']:
    env['SERIALIZE_USE_EXPAT']=1
else:
    env['SERIALIZE_USE_EXPAT']=0

if env['ENABLE_BOUNCE'] or env['ENABLE_ALL']:
    env['REQUIRE_LIBAVC']=1
else:
    env['REQUIRE_LIBAVC']=0

if not env.GetOption('clean'):
    #
    # Check for working gcc and g++ compilers and their environment.
    #
    if not conf.CompilerCheck():
        print "\nIt seems as if your system isn't even able to compile any C-/C++-programs. Probably you don't have gcc and g++ installed. Compiling a package from source without a working compiler is very hard to do, please install the needed packages.\nHint: on *ubuntu you need both gcc- and g++-packages installed, easiest solution is to install build-essential which depends on gcc and g++."
        Exit( 1 )

    # Check for pkg-config before using pkg-config to check for other dependencies.
    if not conf.CheckForPKGConfig():
        print "\nThe program 'pkg-config' could not be found.\nEither you have to install the corresponding package first or make sure that PATH points to the right directions."
        Exit( 1 )

    #
    # The following checks are for headers and libs and packages we need.
    #
    allpresent = 1;
    # for DBUS C++ bindings and cache-serialization.
    allpresent &= conf.CheckHeader( "expat.h" )
    allpresent &= conf.CheckLib( 'expat', 'XML_ExpatVersion', '#include <expat.h>' )

    pkgs = {
        'libraw1394' : '1.3.0',
        'libiec61883' : '1.1.0',
        }

    if env['REQUIRE_LIBAVC']:
        pkgs['libavc1394'] = '0.5.3'

    if not env['SERIALIZE_USE_EXPAT']:
        pkgs['libxml++-2.6'] = '2.13.0'

    for pkg in pkgs:
        name2 = pkg.replace("+","").replace(".","").replace("-","").upper()
        env['%s_FLAGS' % name2] = conf.GetPKGFlags( pkg, pkgs[pkg] )
        #print '%s_FLAGS' % name2
        if env['%s_FLAGS'%name2] == 0:
            allpresent &= 0

    if not allpresent:
        print """
(At least) One of the dependencies is missing. I can't go on without it, please
install the needed packages for each of the lines saying "no".
(Remember to also install the *-devel packages!)

And remember to remove the cache with "rm -Rf .sconsign.dblite cache" so the
results above get rechecked.
"""
        Exit( 1 )

    # Check for C99 lrint() and lrintf() functions used to convert from
    # float to integer more efficiently via float_cast.h.  If not
    # present the standard slower methods will be used instead.  This
    # might not be the best way of testing for these but it's the only
    # way which seems to work properly.  CheckFunc() fails due to
    # argument count problems.
    if env.has_key( 'CFLAGS' ):
        oldcf = env['CFLAGS']
    else:
        oldcf = ""
    oldcf = env.Append(CFLAGS = '-std=c99')
    if conf.CheckLibWithHeader( "m", "math.h", "c", "lrint(3.2);" ):
        HAVE_LRINT = 1
    else:
        HAVE_LRINT = 0
    if conf.CheckLibWithHeader( "m", "math.h", "c", "lrintf(3.2);" ):
        HAVE_LRINTF = 1
    else:
        HAVE_LRINTF = 0
    env['HAVE_LRINT'] = HAVE_LRINT;
    env['HAVE_LRINTF'] = HAVE_LRINTF;
    env.Replace(CFLAGS=oldcf)

#
# Optional checks follow:
#

# PyQT checks
build_mixer = False
if conf.CheckForApp( 'which pyuic4' ) and conf.CheckForPyModule( 'dbus' ) and conf.CheckForPyModule( 'PyQt4' ) and conf.CheckForPyModule( 'dbus.mainloop.qt' ):
    env['PYUIC4'] = True
    build_mixer = True

if conf.CheckForApp( 'xdg-desktop-menu --help' ):
    env['XDG_TOOLS'] = True
else:
    print """
I couldn't find the program 'xdg-desktop-menu'. Together with xdg-icon-resource
this is needed to add the fancy entry to your menu. But if the mixer will be
installed, you can start it by executing "ffado-mixer".
"""

if not build_mixer and not env.GetOption('clean'):
    print """
I couldn't find all the prerequisites ('pyuic4' and the python-modules 'dbus'
and 'PyQt4', the packages could be named like dbus-python and PyQt) to build the
mixer.
Therefor the qt4 mixer will not get installed.
"""

#
# Optional pkg-config
#
pkgs = {
    'alsa': '0',
    'dbus-1': '1.0',
    }
for pkg in pkgs:
    name2 = pkg.replace("+","").replace(".","").replace("-","").upper()
    env['%s_FLAGS' % name2] = conf.GetPKGFlags( pkg, pkgs[pkg] )

#
# Get the directory where dbus stores the service-files
#
if env['DBUS1_FLAGS']:
    env['dbus_service_dir'] = conf.GetPKGVariable( 'dbus-1', 'session_bus_services_dir' ).strip()
    # this is required to indicate that the DBUS version we use has support
    # for platform dependent threading init functions
    # this is true for DBUS >= 0.96 or so. Since we require >= 1.0 it is
    # always true
    env.MergeFlags( "-DDBUS_HAS_THREADS_INIT_DEFAULT" )
else:
    print """
The dbus-headers where not found. The dbus-server for ffado will therefor not be built.
"""

=== debian/changelog ===
libffado (2.0.1+svn1856-5) unstable; urgency=low

  * Ease backporting to Debian stable:
    + Relax inclusion of CDBS snippet utils.mk (handled gracefully if
      missing - i.e. using older versions of cdbs).
    + Relax versioned build-dependency on cdbs (utils.mk no longer
      required but support for debhelper compat level 7 is, so
      unfortunately version in Debian stable is still insuficient).
    + Stop build-depending on devscripts (copyright-check not yet used).
  * Drop needlessly breaking/replacing ffado-python-support. Thanks to
    Adam D. Barratt (see bug#597119).
  * Fix tighten gitignore on .pc subdir.
  * Add source local-options to ease building with git-buildpackage.
  * Add myself as uploader.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 17 Oct 2010 00:26:17 +0200

libffado (2.0.1+svn1856-4) unstable; urgency=low

  * Install 60-ffado.rules udev rules to chown firewire audio devices to the
    audio group.

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Thu, 14 Oct 2010 22:53:32 +0200

libffado (2.0.1+svn1856-3) unstable; urgency=low

  [ Jonas Smedegaard ]
  * Fix have ffado-tools replace older ffado-mixer-qt4.
  * Tighten build-dependency on cdbs slightly.
  * Simplify resolving parallel compilation using example code snippet
    from Debian Policy.

  [ Adrian Knoth ]
  * Drop ffado-python-support and provide the files in ffado-tools instead.
  * Make ffado-mixer-qt4 depend on ffado-tools.

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Wed, 29 Sep 2010 16:57:03 +0200

libffado (2.0.1+svn1856-2) unstable; urgency=low

  * Fix homepage entry. (drop Ubuntu)
  * Compile with -fPIC. 
  * Refactor common python code into ffado-python-support
    (Closes: #594568) (LP: #524702 #624514)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Wed, 15 Sep 2010 17:38:28 +0200

libffado (2.0.1+svn1856-1) unstable; urgency=low

  [ Alessio Treglia ]
  * debian/{control,rules}:
    - Add quilt support.
    - Use python-support as helper for python extensions.
  * Append ${python:Depends} macro to the Depends field of ffado-mixer-qt4.
  * ffado-mixer-qt4 provide only arch-indep stuff, so
    the proper value of the Architecture fields i all.

  [ Adrian Knoth ]
  * New upstream version (Closes: #565025)
  * Support python-2.6 (Closes: #585990)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Tue, 15 Jun 2010 22:05:15 +0200

libffado (2.0.0+svn1813-1) unstable; urgency=low

  * Include python site-packages for ffado-mixer (Closes: #578499)
  * Provide source format (1.0) file to please lintian.
  * New upstream version (new supported device: TC Electronic Konnekt6)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Tue, 20 Apr 2010 14:25:22 +0200

libffado (2.0.0+svn1806-2) unstable; urgency=low

  [ Reinhard Tartler ]
  * convert to multiline fields

  [ Jonathan Riddell ]
  * drop unnecessary build-depend, Closes: #576069

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Thu, 01 Apr 2010 13:38:49 +0200

libffado (2.0.0+svn1806-1) unstable; urgency=low

  * New upstream release (fixes FTBFS on powerpc)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Sat, 20 Mar 2010 14:37:28 +0100

libffado (2.0.0+svn1804-1) unstable; urgency=low

  * Switch to FFADO-trunk to enable support for DICE based devices
  * New upstream version
  * Make it run on the Juju stack (Closes: #565342)
  * Build with debugging again (Closes: #572141)
  * Fix FTBFS with binutils-gold (Closes: #555176)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Tue, 02 Mar 2010 14:57:25 +0100

libffado (2.0.0-1) unstable; urgency=low

  * New upstream version
  * Don't do a DEBUG build. Upstream also defaults to false.

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Sat, 19 Dec 2009 13:56:03 +0100

libffado (2.0~rc2+svn1569-2) unstable; urgency=low

  * Fix FTBS on powerpc (Closes: #534837)
  * Fix lintian warning regarding obsolete dh_desktop
  * Bump standards version to 3.8.2

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Sat, 27 Jun 2009 14:55:45 +0200

libffado (2.0~rc2+svn1569-1) unstable; urgency=low

  * New Upstream Version
  * Fixed gcc-4.4 FTBFS (Closes: #529266)
  * Be more descriptive about ffado-tools (Closes: #529298)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Mon, 18 May 2009 10:54:08 +0200

libffado (2.0~rc1+svn1539-1) unstable; urgency=low

  * Initial Debian inclusion, based on Ubuntu (Closes: #501502)
  * Bumped standards version
  * Limit architecture to i386, amd64 and powerpc
  * Add external sources to copyright file
  * Make the source package depend on debhelper-7
  * Remove Ubuntu's u from libname (libffado.so.0.0.0u)
  * Provide generic man pages (redirecting the user to www.ffado.org for now)
  * Fix lintian warnings about outdated FSF address and unversioned GPL
    reference

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Thu, 12 Mar 2009 17:36:53 +0100

libffado (2.0~rc1-0ubuntu2) jaunty; urgency=low

  * Fix linking against libffado (broken symlink)
  * Rename README.Debian.source to README.source
  * Install a .desktop file for ffado-mixer

 -- Andrew Hunter <andrew@aehunter.net>  Sat, 21 Feb 2009 16:06:22 -0500

libffado (2.0~rc1-0ubuntu1) jaunty; urgency=low

  * Initial Ubuntu inclusion (LP: #246894)
  * Fixed many lintian warnings. 
  * Added additional build-deps to allow ffado-mixer to build on jaunty.
    + Removed quilt from build-deps as it was CDBS boiler-plate in debian/rules.
  * Added dh_makeshlibs options to unbreak ${shlib:}.
  * Link libffado with soname of 0.0.0 (See debian/README.Debian.source for
    details)
  * Fixed typos in debian/control and copyright. 

 -- Andrew Hunter <andrew@aehunter.net>  Mon, 16 Feb 2009 10:52:34 -0500

libffado (2.0~rc1) unstable; urgency=low

  * Upstream sync.

 -- Pieter Palmers <pieter.palmers@ffado.org>  Thu, 22 Nov 2008 22:57:57 +0100

libffado (2.0~beta7-2) unstable; urgency=low

  * Fix DESTDIR packaging bug

 -- Pieter Palmers <pieter.palmers@ffado.org>  Thu, 30 Oct 2008 21:48:57 +0100

libffado (2.0~beta7-1) unstable; urgency=low



=== debian/control ===
Source: libffado
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Free Ekanayaka <freee@debian.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: autotools-dev,
 cdbs (>= 0.4.53),
 debhelper (>= 7.0.1),
 dh-buildinfo,
 scons,
 libraw1394-dev (>= 1.3.0),
 libxml2-dev (>= 2.6.13),
 libiec61883-dev (>= 1.1.0),
 pkg-config,
 dbus (>= 1.0.0),
 python,
 python-dbus,
 python-qt4,
 pyqt4-dev-tools,
 python-support,
 libexpat1-dev,
 libxml++2.6-dev,
 libdbus-1-dev,
 python-qt4-dbus,
 quilt
Standards-Version: 3.9.1
DM-Upload-Allowed: yes
XS-Python-Version: all
Section: libs
Homepage: http://www.ffado.org
Vcs-Git: git://git.debian.org/git/pkg-multimedia/ffado.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/ffado.git

Package: libffado-dev
Section: libdevel
Architecture: i386 amd64 powerpc
Depends: libffado2 (= ${binary:Version}),
  ${misc:Depends},
 libxml2-dev,
 ${shlibs:Depends}
Description: FFADO API - development files
 FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
 .
 The FFADO library permits discovering and configuring such 
 devices and provides an API for streaming clients.
 .
 This package holds the development files.

Package: libffado2
Section: libs
Architecture: i386 amd64 powerpc
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: FFADO API
 FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
 .
 The FFADO library permits discovering and configuring such 
 devices and provides an API for streaming clients.
 .
 This package holds the shared library.

Package: ffado-tools
Section: sound
Architecture: i386 amd64 powerpc
Depends: libffado2 (= ${binary:Version}),
 dbus (>= 1.0.0),
 python,
 ${misc:Depends},
 ${shlibs:Depends}
Replaces: ffado-mixer-qt4 (<< 2.0.1+svn1856-2~)
Breaks: ffado-mixer-qt4 (<< 2.0.1+svn1856-2~)
Description: FFADO debugging and firmware tools
 FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
 .
 The FFADO library permits discovering and configuring such 
 devices and provides an API for streaming clients.
 .
 This package holds the following tools for firmware updating, 
 troubleshooting and debugging:
     * ffado-test-streaming
     * ffado-diag
     * ffado-test-isoxmit
     * ffado-test-isorecv
     * ffado-bridgeco-downloader
     * ffado-test
     * ffado-fireworks-downloader

Package: ffado-dbus-server
Section: sound
Architecture: i386 amd64 powerpc
Depends: libffado2 (= ${binary:Version}),
 dbus (>= 1.0.0),
 ${misc:Depends},
 ${shlibs:Depends}
Description: FFADO D-Bus server
 FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
 .
 The FFADO library permits discovering and configuring such 
 devices and provides an API for streaming clients.
 .
 This package holds the D-Bus server that exposes the mixer 
 and control interfaces through D-Bus.


Package: ffado-mixer-qt4
Section: sound
Architecture: all
Depends: ffado-dbus-server (>= ${source:Version}),
 ffado-tools (>= ${source:Version}),
 ${python:Depends},
 python,
 python-dbus,
 python-qt4,
 python-qt4-dbus,
 ${misc:Depends},
 ${shlibs:Depends}
Description: FFADO D-Bus mixer applets (QT4)
 FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
 .
 The FFADO library permits discovering and configuring such 
 devices and provides an API for streaming clients.
 .
 This package holds the mixer and control applications that 
 communicate with ffado-dbus-server. (Qt4 version)

=== debian/rules ===
#!/usr/bin/make -f
#
# Pieter Palmers <pieter.palmers@ffado.org>
#
# Robert Jordens <jordens@debian.org>
#
# This software may be used and distributed according to the terms
# of the GNU General Public License, incorporated herein by reference.
#

include /usr/share/cdbs/1/rules/debhelper.mk
-include /usr/share/cdbs/1/rules/utils.mk

# Suppress optional build-dependencies
CDBS_BUILD_DEPENDS_rules_utils_copyright-check =

DEB_CLEAN_EXCLUDE=debian/tmp

### Add a soname ###

DEBIAN_FFADO_COMPATIBLE_VERSION = 2.0

CFLAGS += "-fPIC"

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NJOBS += -j$(NUMJOBS)
endif

ifneq (,$(findstring power,$(DEB_BUILD_ARCH)))
EXPLICIT_TARGET = DIST_TARGET=powerpc
else ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
EXPLICIT_TARGET = DIST_TARGET=i386
else
EXPLICIT_TARGET =
endif

DEB_SCONS_EXTRA_FLAGS := \
	PREFIX=/usr \
	SHAREDIR=/usr/share/libffado2/ \
	PYPKGDIR=/usr/share/ffado-mixer-qt4/ \
	WILL_DEAL_WITH_XDG_MYSELF=1 \
	$(EXPLICIT_TARGET) \
	$(NJOBS)


DEB_SCONS_NOOPT_FLAGS := DEBUG=1 ENABLE_OPTIMIZATION=no

DEB_DH_MAKESHLIBS_ARGS := --version-info="libffado2 (>=${DEBIAN_FFADO_COMPATIBLE_VERSION})"

DEB_SCONS_ENVVARS :=
DEB_SCONS_INVOKE = $(DEB_SCONS_ENVVARS) scons 

#common-build-arch:: debian/stamp-scons-build
### Mangle libffado filename ###
debian/stamp-scons-build:
	-mkdir -p $(DEB_DESTDIR)
	$(DEB_SCONS_INVOKE) 'COMPILE_FLAGS=$(CFLAGS)' DESTDIR=$(DEB_DESTDIR) \
		$(DEB_SCONS_EXTRA_FLAGS) $(DEB_SCONS_NOOPT_FLAGS) 
	$(DEB_SCONS_INVOKE) 'COMPILE_FLAGS=$(CFLAGS)' DESTDIR=$(DEB_DESTDIR) \
		$(DEB_SCONS_EXTRA_FLAGS) $(DEB_SCONS_NOOPT_FLAGS) \
		install
	touch debian/stamp-scons-build

# this is bad but the only easy way to have ardour.rc generated from
# ardour.rc.in
common-install-indep:: debian/stamp-scons-build
common-install-arch:: debian/stamp-scons-build

clean:: scons-clean
scons-clean::
	$(MAKE) -f debian/rules reverse-config
	-mkdir -p $(DEB_DESTDIR)
	-$(DEB_SCONS_INVOKE) --clean
	-rm -rf $(DEB_DESTDIR) debian/stamp-scons-build
	-rm -rf config.log scache.conf .sconf_temp .sconsign.dblite cache
	-rm -rf admin/*.pyc

binary-install/ffado-mixer-qt4::
	dh_pysupport -pffado-mixer-qt4

binary-install/ffado-tools::
	dh_pysupport -pffado-tools
